#include <stdio.h>
#include <stdlib.h>

typedef struct endereco
{
    char rua[31];
    char bairro[21];
    int casa;
} Endereco;

typedef struct cliente
{
    char nome[21];
    int cpf;
    int fone;
    Endereco ende;
    char ativacao[11];
} Cliente;

void cadastro(FILE *arq)
{
    Cliente c;
    printf("Digite o Nome do Cliente, CPF, Fone, Rua, Bairro, Numero da casa e Ativacao:\n");
    scanf(" %20s %d %d %30s %20s %d %10s", c.nome, &c.cpf, &c.fone, c.ende.rua, c.ende.bairro, &c.ende.casa, c.ativacao);
    fprintf(arq, "%s %d %d %s %s %d %s\n", c.nome, c.cpf, c.fone, c.ende.rua, c.ende.bairro, c.ende.casa, c.ativacao);
    printf("Cliente cadastrado.\n");
}

int buscar(FILE *arq, int telefone)
{
    Cliente c;
    int i = 1, aux = 1;
    while((!feof(arq)) && (aux != 0))
    {
        fscanf(arq,"%20s %d %d %30s %20s %d %10s", c.nome, &c.cpf, &c.fone, c.ende.rua, c.ende.bairro, &c.ende.casa, c.ativacao);
        if(c.fone == telefone)
        {
            aux = 0;
        }
        i++;
    }
    if(aux == 0)
        i = i - 1;
    else
        i = 0;
    return i; //retorna a linha que o cliente foi escrito no programa.
}

void imprimir(FILE* arq)
{
    Cliente c;
    int i = 1;
    printf("\nLista de Clientes:");
    while(!feof(arq))
    {
        fscanf(arq,"%20s %d %d %30s %20s %d %10s", c.nome, &c.cpf, &c.fone, c.ende.rua, c.ende.bairro, &c.ende.casa, c.ativacao);
        printf("\nCliente %d\n", i++);
        printf("Nome: %s\nCPF: %d\nFone: %d\nRua: %s\nBairro: %s\nNumero: %d\nData de ativacao: %s\n", c.nome, c.cpf, c.fone, c.ende.rua, c.ende.bairro, c.ende.casa, c.ativacao);
    }
}

int main()
{
    FILE *arquivo;
    arquivo = fopen("CLIENTES.txt", "w+");
    int aux = 1, opcao, tel, posicao;
    while(aux)
    {
        printf("\nMenu:\n1 - Cadastrar\n2 - Pesquisar cliente\n3 - Imprimir lista de clientes\n4 - Sair\n");
        printf("Digite a opcao escolhida: ");
        scanf("%d", &opcao);
        switch (opcao)
        {
            case 1: fseek(arquivo, 0, SEEK_END);
                    cadastro(arquivo);
                    break;
            case 2: printf("\nDigite o telefone: ");
                    scanf("%d", &tel);
                    fseek(arquivo, 0, SEEK_SET);
                    posicao = buscar(arquivo, tel);
                    if(posicao > 0)
                        printf("\nCliente encontrado na posicao %d.\n", posicao);
                    else
                        printf("\nCliente nao encontrado!\n");
                    break;
            case 3: fseek(arquivo, 0, SEEK_SET);
                    imprimir(arquivo);
                    break;
            case 4: aux = 0;
                    break;
            default: printf("\nOpcao invalida.");
        }
    }
    fclose(arquivo);
    return 0;
}
